<template>
  <Row class="manager-stock-data-company">
    <i-col :span="12" class="content-block">
      <stock-search-block
          :fields="search.fields"
          :default-field="search.column"
          @on-search="searchAction">
        <template slot="btn-block">
          <div class="literal-div-btn create-btn" @click="addNewCompanyAction">New Company</div>
        </template>

        <template>
          <stock-company-card v-for="(company, index) in companiesToShow" :key="`${timestamp}-${index}`"
                              :lg="8" :md="8"
                              :company="company" @on-click="companyClickAction(company.id, 'view')">
            <Button class="company-card-btn" type="primary" shape="circle" icon="md-create"
                    @click.native.stop="companyClickAction(company.id, 'edit')">
            </Button>
          </stock-company-card>
        </template>
      </stock-search-block>
    </i-col>

    <i-col :span="12" class="content-block">
      <div class="form-block">
        <!-- new company   -->
        <template v-if="showNewCompanyForm">
          <stock-form id="new-company-info" title="New Company">
            <stock-form-item v-for="(field, index) in schemaFields(companyForm.schema)" :key="`${timestamp}-${field}`"
                             v-model="companyForm.data[field]"
                             :options="companyForm.schema[field]"
                             :error="companyForm.error[field]"
                             :edit="true">
            </stock-form-item>
            <br><br>
            <Row>
              <div class="literal-div-btn cancel-btn" @click="cancelAddNweCompanyAction">Cancel</div>
              <div class="literal-div-btn submit-btn" @click="submitNewCompanyAction">Submit</div>
            </Row>
          </stock-form>
        </template>

        <!-- exist company -->
        <template v-if="focusType" >
          <stock-form id="company-info" title="Company Information">
            <stock-form-item v-for="(field, index) in schemaFields(companyForm.schema)" :key="`${timestamp}-${focusCompanyId}-${field}`"
                             v-model="companies[focusCompanyId][field]"
                             :options="companyForm.schema[field]"
                             :error="companyForm.error[field]"
                             :edit="focusType === 'edit'">
            </stock-form-item>
            <br><br>
            <Row v-if="focusType === 'edit'">
              <div class="literal-div-btn cancel-btn" @click="cancelEditAction">Cancel</div>
              <div class="literal-div-btn edit-btn" @click="updateCompanyAction">Update</div>
            </Row>
          </stock-form>
        </template>
      </div>
    </i-col>
  </Row>
</template>

<script>
import * as form from '../../../helpers/form';
import StockQuickSearch from '../../../components/StockQuickSearch'
import StockForm from '../../../components/StockForm'
import StockFormItem from '../../../components/StockFormItem'
import StockCompanyCard from '../../../components/StockCompanyCard'
import StockSearchBlock from '../../../components/StockSearchBlock'
import { validators as api } from '../../../configs/request-validator/company';

const actions = {
  addNewCompanyAction() {
    this.focusType = false;
    this.resetCurrentFocusCompany();
    this.resetCompanyFormData();
    this.showNewCompanyForm = true;
  },
  async submitNewCompanyAction() {
    try {
      const { data } = await this.$api(api.AddCompanyRequest, this.companyForm.data);
      const newCompanyId = data.id;
      this.companies[newCompanyId] = data;
      this.showNewCompanyForm = false;
      this.resetCompanyFormData();
    } catch (error) {
      this.companyForm.error = this.$apiErrorHandler(error) || {};
    }
  },
  cancelAddNweCompanyAction() {
    this.showNewCompanyForm = false;
    this.resetCompanyFormData();
  },
  searchAction({ searchColumn, searchValue }) {
    this.search.column = searchColumn;
    this.search.value = searchValue;
  },
  companyClickAction(companyId, type) {
    this.showNewCompanyForm = false;
    this.resetCompanyFormData();
    this.focusCompanyId = companyId;
    this.focusType = type;
    const isEdit = type === 'edit';
    if (isEdit) {
      this.copyFocusCompany = {
        ...this.companies[companyId]
      };
    }
  },
  async updateCompanyAction() {
    this.companyForm.data = {
      ...this.companies[this.focusCompanyId],
      companyId: this.focusCompanyId,
    };

    try {
      const { data } = await this.$api(api.UpdateCompanyRequest, this.companyForm.data);
      const updateCompany = data;
      const updateCompanyId = updateCompany.id;
      this.resetCurrentFocusCompany();
      Object.keys(updateCompany).forEach(key => {
        this.companies[updateCompanyId][key] = updateCompany[key];
      });
    } catch (error) {
      this.companyForm.error = this.$apiErrorHandler(error) || {};
    }
  },
  cancelEditAction() {
    this.resetCurrentFocusCompany();
  }
};

export default {
  name: 'company',
  mixins: [ form.mixin ],
  components: { StockSearchBlock, StockCompanyCard, StockFormItem, StockForm, StockQuickSearch },
  data() {
    return {
      companies: undefined,
      companyForm: undefined,
      search: {
        column: 'stockCode',
        value: undefined,
        fields: [
          { value: 'id', label: 'ID' },
          { value: 'stockCode', label: 'Code' },
          { value: 'name', label: 'Name' },
        ]
      },
      focusCompanyId: undefined,
      focusType: undefined,
      copyFocusCompany: undefined,
      showNewCompanyForm: false,
      companiesToShow: [],
      timestamp: new Date().getTime(),
    };
  },
  computed: {},
  watch: {
    ['search.column']() {
      this.rerenderCompaniesToShow();
    },
    ['search.value']() {
      this.rerenderCompaniesToShow();
    },
  },
  methods: {
    ...actions,
    resetCurrentFocusCompany() {
      this.companyForm.error = [];
      if (this.copyFocusCompany) {
        Object.keys(this.copyFocusCompany).forEach(key => {
          this.companies[this.focusCompanyId][key] = this.copyFocusCompany[key];
        });
      }
      this.focusCompanyId = undefined;
      this.focusType = undefined;
      this.copyFocusCompany = undefined;
    },
    resetCompanyFormData() {
      this.companyForm.data.name = undefined;
      this.companyForm.data.stockData = undefined;
      this.companyForm.error = [];
      this.forceRender();
    },
    rerenderCompaniesToShow() {
      this.companiesToShow = [];
      const toFilter = this.search.column && this.search.value;
      const getAll = !this.search.value;
      if (toFilter) {
        Object.keys(this.companies).forEach(key => {
          const company = this.companies[key];
          const matchFilter = company[this.search.column].toString().includes(this.search.value);
          if (matchFilter) {
            this.companiesToShow.push(company);
          }
        });
      } else if (getAll) {
        this.companiesToShow = this.companies;
      }
      this.forceRender();
    },
    forceRender() {
      this.timestamp = new Date().getTime();
    }
  },
  mounted() {
    this.$displayBodyBlock(false);
    this.rerenderCompaniesToShow();
  },
  async asyncData({ app, store }) {
    let companies = undefined;
    const hasCompanies = store.getters['company/hasCompanies'];

    if (hasCompanies) {
      companies = store.getters['company/companies'];
    } else {
      // request
      const companiesData = {};

      // invoke api
      try {
        const allResponseData = await Promise.all([
          app.$api(api.GetAllCompanyRequest, companiesData, undefined, false),
        ]);

        // set vue data
        companies = allResponseData[0]['data'];

        // store in vuex
        store.dispatch('company/setCompanies', companies);
      } catch (error) {
        app.$apiErrorHandler(error);
      }
    }

    const companyForm = {
      schema: {
        name: { type: 'text', title: 'Name' },
        stockCode: { type: 'text', title: 'Stock Code' },
      },
      rules: api.AddCompanyRequest.body,
      data: {
        name: undefined,
        stockData: undefined,
      },
      error: {},
    };

    return {
      companies,
      companyForm,
    };
  }
}
</script>

<style lang="scss" scoped>
  @import "../../../assets/css/mixin";

  .manager-stock-data-company {
    height: 100%;
    .content-block {
      height: 100%;
      padding: 10px 15px;
      overflow-y: auto;
      .form-block {
        height: calc(100% - 80px);
        margin-top: 80px;
        padding: 10px;
      }
    }
  }
</style>
